Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/Preprocessor.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/Preprocessor.vcproj	(revision 1138)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/Preprocessor.vcproj	(revision 1145)
@@ -164,19 +164,4 @@
 			</File>
 			<File
-				RelativePath="..\src\GlRenderer.cpp">
-			</File>
-			<File
-				RelativePath="..\src\GlRenderer.h">
-				<FileConfiguration
-					Name="Release|Win32">
-					<Tool
-						Name="VCCustomBuildTool"
-						Description="Performing moc on $(InputName).h"
-						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp
-"
-						Outputs="$(InputDir)moc_$(InputName).cpp"/>
-				</FileConfiguration>
-			</File>
-			<File
 				RelativePath="..\src\GzBinFileInputStream.cpp">
 			</File>
@@ -246,13 +231,4 @@
 			<File
 				RelativePath="..\src\MeshKdTree.h">
-			</File>
-			<File
-				RelativePath="..\src\moc_GlRenderer.cpp">
-			</File>
-			<File
-				RelativePath="..\src\moc_Preprocessor.cpp">
-			</File>
-			<File
-				RelativePath="..\src\moc_PreprocessorThread.cpp">
 			</File>
 			<File
@@ -356,10 +332,4 @@
 			</File>
 			<File
-				RelativePath="..\src\Renderer.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Renderer.h">
-			</File>
-			<File
 				RelativePath="..\src\RenderSampler.cpp">
 			</File>
@@ -548,4 +518,26 @@
 			<File
 				RelativePath="..\include\ViewCell.h">
+			</File>
+		</Filter>
+		<Filter
+			Name="Renderer"
+			Filter="">
+			<File
+				RelativePath="..\src\GlRenderer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\GlRenderer.h">
+			</File>
+			<File
+				RelativePath="..\src\QtGlRenderer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\QtGlRenderer.h">
+			</File>
+			<File
+				RelativePath="..\src\Renderer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\Renderer.h">
 			</File>
 		</Filter>
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/TestPreprocessor.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/TestPreprocessor.vcproj	(revision 1077)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/TestPreprocessor.vcproj	(revision 1145)
@@ -70,5 +70,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalIncludeDirectories="..\include;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;&quot;$(CG_INC_PATH)&quot;;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces"
+				AdditionalIncludeDirectories="..\include;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(BOOST_INCLUDE)&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;&quot;$(CG_INC_PATH)&quot;;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
 				RuntimeLibrary="2"
@@ -85,5 +85,5 @@
 				OutputFile="$(OutDir)/Preprocessor.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="..\support\xercesc\lib\;..\support\zlib\lib\;..\support\devil\lib;&quot;$(QTDIR)\lib&quot;;..\include;..\src\GL;&quot;$(CG_LIB_PATH)&quot;;&quot;$(GTPDIR)\NonGTP\Xerces&quot;;&quot;$(GTPDIR)\NonGTP\Xerces\xercesc\lib&quot;;&quot;$(GTPDIR)\NonGTP\zlib\lib&quot;;&quot;$(GTPDIR)\NonGTP\Devil\lib&quot;;..\lib\release;..\..\Preprocessing\lib\release"
+				AdditionalLibraryDirectories="..\support\xercesc\lib\;..\support\zlib\lib\;..\support\devil\lib;&quot;$(QTDIR)\lib&quot;;..\include;..\src\GL;&quot;$(CG_LIB_PATH)&quot;;&quot;$(GTPDIR)\NonGTP\Xerces&quot;;&quot;$(GTPDIR)\NonGTP\Xerces\xercesc\lib&quot;;&quot;$(GTPDIR)\NonGTP\zlib\lib&quot;;&quot;$(GTPDIR)\NonGTP\Devil\lib&quot;;..\lib\release;..\..\Preprocessing\lib\release;&quot;$(BOOST_LIB)&quot;"
 				GenerateDebugInformation="FALSE"
 				SubSystem="1"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.cpp	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.cpp	(revision 1145)
@@ -1,7 +1,4 @@
-//#include "glInterface.h"
 #include "OcclusionQuery.h"
 #include <iostream>
-//#include <GL/gl.h>
-//#include <QtOpenGL>
 #include <glInterface.h>
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1141)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1145)
@@ -640,5 +640,7 @@
 	// compute first split candidate
 	VspBspSplitCandidate splitCandidate;
-	EvalSplitCandidate(tData, splitCandidate);
+	splitCandidate.mParentData = tData;
+
+	EvalSplitCandidate(splitCandidate);
 
 	tQueue.push(splitCandidate);
@@ -814,20 +816,6 @@
 			// evaluate subdivision stats
 			if (1)
-			{
-				const float cFront = (float)tFrontData.mPvs * tFrontData.mProbability;
-				const float cBack = (float)tBackData.mPvs * tBackData.mProbability;
-				const float cData = (float)tData.mPvs * tData.mProbability;;
-
-                const float costDecr = (cFront + cBack - cData) / mBox.GetVolume();
-
-				mTotalCost += costDecr;
-				mTotalPvsSize += tFrontData.mPvs + tBackData.mPvs - tData.mPvs;
-
-				AddSubdivisionStats(mBspStats.Leaves(),
-								    -costDecr,
-									0,
-									mTotalCost,
-									(float)mTotalPvsSize / (float)mBspStats.Leaves());
-			}
+				EvalSubdivisionStats(tData, tFrontData, tBackData);
+			
 
 			// push the children on the stack
@@ -964,8 +952,11 @@
 		//-- push the new split candidates on the stack
 		VspBspSplitCandidate frontCandidate;
+		frontCandidate.mParentData = tFrontData;
+
 		VspBspSplitCandidate backCandidate;
-
-		EvalSplitCandidate(tFrontData, frontCandidate);
-		EvalSplitCandidate(tBackData, backCandidate);
+		backCandidate.mParentData = tBackData;
+
+		EvalSplitCandidate(frontCandidate);
+		EvalSplitCandidate(backCandidate);
 	
 		tQueue.push(frontCandidate);
@@ -1047,4 +1038,5 @@
 
 
+/*
 void VspBspTree::EvalSplitCandidate(VspBspTraversalData &tData,
 									VspBspSplitCandidate &splitData)
@@ -1067,4 +1059,69 @@
 	splitData.mParentData = tData;
 	splitData.mMaxCostMisses = success ? tData.mMaxCostMisses : tData.mMaxCostMisses + 1;
+}
+*/
+
+void VspBspTree::EvalSplitCandidate(VspBspSplitCandidate &splitCandidate)
+{
+	VspBspTraversalData frontData;
+	VspBspTraversalData backData;
+	
+	BspLeaf *leaf = dynamic_cast<BspLeaf *>(splitCandidate.mParentData.mNode);
+	
+	// compute locally best split plane
+    bool success = SelectPlane(splitCandidate.mSplitPlane, leaf, splitCandidate.mParentData, 
+							   frontData, backData, splitCandidate.mSplitAxis);
+
+	float oldRenderCost;
+
+	// compute global decrease in render cost
+	const float renderCostDecr = EvalRenderCostDecrease(splitCandidate.mSplitPlane, 
+														splitCandidate.mParentData,
+														oldRenderCost);
+
+	splitCandidate.mRenderCostDecr = renderCostDecr;
+
+	// TODO: geometry could be reused
+	delete frontData.mGeometry;
+	delete backData.mGeometry;
+
+	// set priority for queue
+#if 0
+	const float priority = (float)-data.mDepth;
+#else	
+
+	// take render cost of node into account 
+	// otherwise danger of being stuck in a local minimum!!
+	const float factor = mRenderCostDecreaseWeight;
+	const float priority = factor * renderCostDecr + (1.0f - factor) * oldRenderCost;
+#endif
+	
+	splitCandidate.mPriority = priority;
+
+	// max cost threshold violated?
+	splitCandidate.mMaxCostMisses = 
+		success ? splitCandidate.mParentData.mMaxCostMisses : splitCandidate.mParentData.mMaxCostMisses + 1;
+}
+
+
+void VspBspTree::EvalSubdivisionStats(const VspBspTraversalData &tData,
+									  const VspBspTraversalData &tFrontData,
+									  const VspBspTraversalData &tBackData)
+{
+	const float cFront = (float)tFrontData.mPvs * tFrontData.mProbability;
+	const float cBack = (float)tBackData.mPvs * tBackData.mProbability;
+	const float cData = (float)tData.mPvs * tData.mProbability;
+	
+	const float costDecr = 
+		(cFront + cBack - cData) / mBox.GetVolume();
+
+	mTotalCost += costDecr;
+	mTotalPvsSize += tFrontData.mPvs + tBackData.mPvs - tData.mPvs;
+
+	AddSubdivisionStats(mBspStats.Leaves(),
+						-costDecr,
+						0,
+						mTotalCost,
+						(float)mTotalPvsSize / (float)mBspStats.Leaves());
 }
 
@@ -1896,5 +1953,6 @@
 
 float VspBspTree::EvalRenderCostDecrease(const Plane3 &candidatePlane,
-										 const VspBspTraversalData &data) const
+										 const VspBspTraversalData &data,
+										 float &normalizedOldRenderCost) const
 {
 	float pvsFront = 0;
@@ -1972,13 +2030,10 @@
 	const float newRenderCost = penaltyFront * pFront + penaltyBack * pBack;
 
-	//Debug << "decrease: " << oldRenderCost - newRenderCost << endl;
 	const float renderCostDecrease = (oldRenderCost - newRenderCost) / mBox.GetVolume();
 	
-	const float weight = mRenderCostDecreaseWeight;
 	// take render cost of node into account to avoid being stuck in a local minimum
-	const float normalizedOldRenderCost = oldRenderCost / mBox.GetVolume();
-	
-	//Debug << "rendercostdecr: " << weight * renderCostDecrease << " old render cost: " << (1.0f - weight) * normalizedOldRenderCost << endl;
-	return weight * renderCostDecrease + (1.0f - weight) * normalizedOldRenderCost;
+	normalizedOldRenderCost = oldRenderCost / mBox.GetVolume();
+	
+	return renderCostDecrease;
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 1142)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 1145)
@@ -41,5 +41,6 @@
 
 
-/** Probably Visible Set */
+/** Probably Visible Set 
+*/
 class PrVs 
 {
@@ -379,7 +380,7 @@
 	void SetViewCellsActive();
 
-	/** Evaluates worth of current view cell hierarchy.
-	*/
-	void EvalViewCellPartition(Preprocessor *preprocessor);
+	/** Evaluates render cost statistics of current view cell hierarchy.
+	*/
+	void EvalViewCellPartition();
 
 	/** Sets maximal size of a view cell filter.
@@ -479,4 +480,5 @@
 
 protected:
+
 	/** Exports bounding boxes as xml stream
 	*/
@@ -570,5 +572,6 @@
 	////////////////////////////////////////////////
 
-	/// if bounding boxes should also be exported
+	Preprocessor *mPreprocessor;
+	/// if bounding boxes should be exported together with the view cells
 	bool mExportBboxesForPvs;
 		
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 1144)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 1145)
@@ -21,5 +21,5 @@
 const static bool ADDITIONAL_GEOMETRY_HACK = false;
 
-Preprocessor *preprocessor;
+//Preprocessor *preprocessor;
 
 
@@ -163,9 +163,11 @@
   cout << "done.\n";
  
-#if 0
-  cout << "Deleting vsp osp tree...\n";
-  DEL_PTR(mVspOspTree);
+  cout << "Deleting vsp tree...\n";
+  DEL_PTR(mVspTree);
   cout << "done.\n";
-#endif
+
+  cout << "Deleting osp tree...\n";
+  DEL_PTR(mOspTree);
+  cout << "done.\n";
 
   cout << "Deleting vspbsp tree...\n";
@@ -408,5 +410,6 @@
 		// NOTE: render texture should be power of 2 and square
 		// renderer must be initialised
-		renderer = new GlRendererBuffer(1024, 768, mSceneGraph, mViewCellsManager, mKdTree);
+		// $$matt
+//		renderer = new GlRendererBuffer(1024, 768, mSceneGraph, mViewCellsManager, mKdTree);
 		//		renderer->makeCurrent();
 		
@@ -468,5 +471,5 @@
 
 
-inline bool ilt(Intersectable *obj1, Intersectable *obj2)
+static inline bool ilt(Intersectable *obj1, Intersectable *obj2)
 {
 	return obj1->mId < obj2->mId;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp	(revision 1112)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp	(revision 1145)
@@ -484,4 +484,5 @@
 {
   // compute rendering error
+	
   if (renderer && renderer->mPvsStatFrames) {
 	//	emit EvalPvsStat();
@@ -835,8 +836,18 @@
 
 	if (0 && mPass > 0) {
+		char buf[100];
 	  if (mUseImportanceSampling)
-		renderer->mSnapPrefix.sprintf("snap/i-%02d-", mPass);
+	  {
+		sprintf(buf, "snap/i-%02d-", mPass);
+
+		renderer->mSnapPrefix = buf;
+	  }
 	  else
-		renderer->mSnapPrefix.sprintf("snap/r-%02d-", mPass);
+	  {
+		sprintf(buf, "snap/r-%02d-", mPass);
+
+		renderer->mSnapPrefix = buf;
+	  }
+
 	  renderer->mSnapErrorFrames = true;
 	}
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VssPreprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VssPreprocessor.cpp	(revision 1076)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VssPreprocessor.cpp	(revision 1145)
@@ -432,5 +432,6 @@
 	exporter->SetFilled();
 	//Randomize();
-	debuggerWidget = new GlDebuggerWidget(renderer);
+// §§matt
+//	debuggerWidget = new GlDebuggerWidget(renderer);
 
 	/*debuggerWidget->mBeam = beam;
@@ -439,7 +440,7 @@
 	
 	Debug << "showing window" << endl;
-	debuggerWidget->show();*/
-	
-	renderer->makeCurrent();
+	debuggerWidget->show();
+	
+	renderer->makeCurrent();*/
 
 	for (int i = 0; i < 10; ++ i)
@@ -464,6 +465,6 @@
 
 		BeamSampleStatistics stats;
-
-		renderer->SampleBeamContributions(sourceObj,
+// §§matt
+/*		renderer->SampleBeamContributions(sourceObj,
 										  beam,
 										  200000,
@@ -475,5 +476,5 @@
 		image.save(s, "PNG");
 		Debug << "beam statistics: " << stats << endl << endl;
-
+*/
 		if (1)
 		{
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.h	(revision 1022)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.h	(revision 1145)
@@ -8,5 +8,6 @@
 #include "KdTree.h"
 
-#include <QObject>
+// matt: remove qt dependencies
+//#include <QObject>
 
 namespace GtpVisibilityPreprocessor {
@@ -33,10 +34,12 @@
 */
   
-  /** Main class of the visibility preprocessor. Responsible for loading and
-      saving of the input and output files. Initiates construction of the kD-tree,
-      viewcell loading/generation and the visibility computation itself.
-  */
-class Preprocessor : public QObject {
-  Q_OBJECT
+/** Main class of the visibility preprocessor. Responsible for loading and
+    saving of the input and output files. Initiates construction of the kD-tree,
+    viewcell loading/generation and the visibility computation itself.
+*/
+// matt: remove qt dependencies
+class Preprocessor// : public QObject 
+{
+  //Q_OBJECT
 
 public:
@@ -49,5 +52,5 @@
   /** Load the input scene. 
       @param filename file to load
-	@return true on success
+	  @return true on success
   */
   virtual bool LoadScene(const string filename);
@@ -202,13 +205,11 @@
 
   GlRendererBuffer *renderer;
-  
-  signals:
+// matt: remove qt dependencies 
+//signals:
   void EvalPvsStat();
 
 };
 
-
-
-extern Preprocessor *preprocessor;
+//extern Preprocessor *preprocessor;
 
 }
